#ifdef GL_ES
    precision mediump float;
#endif

varying vec2 v_texCoords;

uniform sampler2D sceneTex; //the final scene image.

uniform float centerX0;
uniform float centerY0;
uniform float time0; // shockwave elapsed time in second.
uniform float centerX1;
uniform float centerY1;
uniform float time1; // shockwave elapsed time in second.
uniform float centerX2;
uniform float centerY2;
uniform float time2; // shockwave elapsed time in second.
uniform float centerX3;
uniform float centerY3;
uniform float time3; // shockwave elapsed time in second.
uniform float centerX4;
uniform float centerY4;
uniform float time4; // shockwave elapsed time in second.
uniform float centerX5;
uniform float centerY5;
uniform float time5; // shockwave elapsed time in second.
uniform float centerX6;
uniform float centerY6;
uniform float time6; // shockwave elapsed time in second.
uniform float centerX7;
uniform float centerY7;
uniform float time7; // shockwave elapsed time in second.
uniform float centerX8;
uniform float centerY8;
uniform float time8; // shockwave elapsed time in second.
uniform float centerX9;
uniform float centerY9;
uniform float time9; // shockwave elapsed time in second.

uniform vec3 shockParams; // 10.0, 0.8, 0.1  shockwave parameters




void main() 
{ 
  vec2 a_texcoord = vec2(v_texCoords.s, 1.0 - v_texCoords.t); 
  vec2 uv = a_texcoord.xy;
  vec2 texCoord = uv;
  
   if(time0>0.0)
   {
  	  vec2 center = vec2(centerX0, centerY0);
	  float distance = distance(uv, center);
	  if ( (distance <= (time0 + shockParams.z)) && 
		   (distance >= (time0 - shockParams.z)) ) 
	  {
		float diff = (distance - time0); 
		float powDiff = 1.0 - pow(abs(diff*shockParams.x), 
									shockParams.y); 
		float diffTime = diff  * powDiff; 
		vec2 diffUV = normalize(uv - center); 
		texCoord = uv + (diffUV * diffTime);
	  } 
	}
	
	if(time1>0.0)
   {
  	  vec2 center = vec2(centerX1, centerY1);
	  float distance = distance(uv, center);
	  if ( (distance <= (time1 + shockParams.z)) && 
		   (distance >= (time1 - shockParams.z)) ) 
	  {
		float diff = (distance - time1); 
		float powDiff = 1.0 - pow(abs(diff*shockParams.x), 
									shockParams.y); 
		float diffTime = diff  * powDiff; 
		vec2 diffUV = normalize(uv - center); 
		texCoord = uv + (diffUV * diffTime);
	  } 
	}
	
	if(time2>0.0)
   {
  	  vec2 center = vec2(centerX2, centerY2);
	  float distance = distance(uv, center);
	  if ( (distance <= (time2 + shockParams.z)) && 
		   (distance >= (time2 - shockParams.z)) ) 
	  {
		float diff = (distance - time2); 
		float powDiff = 1.0 - pow(abs(diff*shockParams.x), 
									shockParams.y); 
		float diffTime = diff  * powDiff; 
		vec2 diffUV = normalize(uv - center); 
		texCoord = uv + (diffUV * diffTime);
	  } 
	}
	
	if(time3>0.0)
   {
  	  vec2 center = vec2(centerX3, centerY3);
	  float distance = distance(uv, center);
	  if ( (distance <= (time3 + shockParams.z)) && 
		   (distance >= (time3 - shockParams.z)) ) 
	  {
		float diff = (distance - time3); 
		float powDiff = 1.0 - pow(abs(diff*shockParams.x), 
									shockParams.y); 
		float diffTime = diff  * powDiff; 
		vec2 diffUV = normalize(uv - center); 
		texCoord = uv + (diffUV * diffTime);
	  } 
	}
	
	if(time4>0.0)
   {
  	  vec2 center = vec2(centerX4, centerY4);
	  float distance = distance(uv, center);
	  if ( (distance <= (time4 + shockParams.z)) && 
		   (distance >= (time4 - shockParams.z)) ) 
	  {
		float diff = (distance - time4); 
		float powDiff = 1.0 - pow(abs(diff*shockParams.x), 
									shockParams.y); 
		float diffTime = diff  * powDiff; 
		vec2 diffUV = normalize(uv - center); 
		texCoord = uv + (diffUV * diffTime);
	  } 
	}
	
	if(time5>0.0)
   {
  	  vec2 center = vec2(centerX5, centerY5);
	  float distance = distance(uv, center);
	  if ( (distance <= (time5 + shockParams.z)) && 
		   (distance >= (time5 - shockParams.z)) ) 
	  {
		float diff = (distance - time5); 
		float powDiff = 1.0 - pow(abs(diff*shockParams.x), 
									shockParams.y); 
		float diffTime = diff  * powDiff; 
		vec2 diffUV = normalize(uv - center); 
		texCoord = uv + (diffUV * diffTime);
	  } 
	}
	
	if(time6>0.0)
   {
  	  vec2 center = vec2(centerX6, centerY6);
	  float distance = distance(uv, center);
	  if ( (distance <= (time6 + shockParams.z)) && 
		   (distance >= (time6 - shockParams.z)) ) 
	  {
		float diff = (distance - time6); 
		float powDiff = 1.0 - pow(abs(diff*shockParams.x), 
									shockParams.y); 
		float diffTime = diff  * powDiff; 
		vec2 diffUV = normalize(uv - center); 
		texCoord = uv + (diffUV * diffTime);
	  } 
	}
	
	if(time7>0.0)
   {
  	  vec2 center = vec2(centerX7, centerY7);
	  float distance = distance(uv, center);
	  if ( (distance <= (time7 + shockParams.z)) && 
		   (distance >= (time7 - shockParams.z)) ) 
	  {
		float diff = (distance - time7); 
		float powDiff = 1.0 - pow(abs(diff*shockParams.x), 
									shockParams.y); 
		float diffTime = diff  * powDiff; 
		vec2 diffUV = normalize(uv - center); 
		texCoord = uv + (diffUV * diffTime);
	  } 
	}
	
	if(time8>0.0)
   {
  	  vec2 center = vec2(centerX8, centerY8);
	  float distance = distance(uv, center);
	  if ( (distance <= (time8 + shockParams.z)) && 
		   (distance >= (time8 - shockParams.z)) ) 
	  {
		float diff = (distance - time8); 
		float powDiff = 1.0 - pow(abs(diff*shockParams.x), 
									shockParams.y); 
		float diffTime = diff  * powDiff; 
		vec2 diffUV = normalize(uv - center); 
		texCoord = uv + (diffUV * diffTime);
	  } 
	}
	
	if(time9>0.0)
   {
  	  vec2 center = vec2(centerX9, centerY9);
	  float distance = distance(uv, center);
	  if ( (distance <= (time9 + shockParams.z)) && 
		   (distance >= (time9 - shockParams.z)) ) 
	  {
		float diff = (distance - time9); 
		float powDiff = 1.0 - pow(abs(diff*shockParams.x), 
									shockParams.y); 
		float diffTime = diff  * powDiff; 
		vec2 diffUV = normalize(uv - center); 
		texCoord = uv + (diffUV * diffTime);
	  } 
	}
	

  gl_FragColor = texture2D(sceneTex, texCoord);
}

