//attribute开头的定义了每个顶点的参数
attribute vec4 a_position;//定义了每个顶点必须包含一个4维坐
attribute vec4 a_color;//必须包含一个4维颜色坐标，rgba
attribute vec2 a_texCoord0;//必须包含一个二维纹理坐标，0-1

//uniform开头的定义了可供外部配置的参数
uniform mat4 u_projTrans;//定义了一个4维矩阵

//varying开头的定义了用于向片段着色器传递的参数
varying vec4 v_color;//经main函数处理后的顶点颜色
varying vec2 v_texCoords;//处理后的顶点的纹理坐标

//这个函数用于处理顶点信息，将处理后的信息传入到渲染流水线的下一环节
void main() {
    v_color = a_color;//直接将顶点的颜色进行赋值
    v_texCoords = a_texCoord0;//直接将顶点的纹理坐标赋值
    
	//gl_position是内置变量，无须定义，也是必须的。这里将一个外部传入的四维矩阵与顶点坐标相乘后赋值。
	gl_Position = u_projTrans * a_position;
}